/*********************************************************
*Copyright (C), 2015, Shanghai Eastsoft Microelectronics Co., Ltd.
*ļ:  main.c
*  :  ESM Application Team 
*  :  V1.00
*  :  2015/12/01
*  :  UARTģ
*  ע:  HR8P506оƬ
          ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include "lib_config.h"
#include "HR8P506.h"
#include "system_hr8p506.h"
#include "timer.h"
#include "adc.h"
#include "uart.h"
#include "key.h"
#include "oled.h"

#define UART_STOP_FLAG 200
#define UART_START_FLAG 201
#define UART_POSI_FLAG 202
#define UART_MEG_FLAG 203

unsigned char posi_meg_flag = 0;  // 0  1 

__IO uint8_t g_rxbuf;

uint16_t adc_value;
uint16_t speed_value;
/*********************************************************
: int main(void)
  : 
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
int main(void)
{
	SystemInit();				      //ϵͳʼ
	DeviceClockAllEnable();			  //ʱ
	OLED_Init();
	OLED_Clear()  	; 
	
	OLED_ShowString(0,0,"169B_BLDC_V1.0");
	OLED_ShowString(0,2,"SPEED:");
	OLED_ShowString(0,4,"STATE:");
	OLED_ShowString(60,4,"STOP");
	UARTInit(); 				      //UARTʼ
	ADCInit();
	timer32_init();
	key_init();
	
	//UART_SendByte(UART1, 0x55);
	while(UART_GetFlagStatus(UART1, UART_FLAG_TC) == SET);
	while(1)
	{
		adc_value = ADCRead();
		speed_value = adc_value*100/4096;
		
	}
}



struct 
{
	unsigned char header_counter;
	union 
	{
		unsigned char data8[2];
		unsigned short data16;
	}receive_data;
	unsigned char data_motor_state;
	unsigned char data_counter;
}uart_receive_data;



/*********************************************************
: void T32N0_IRQHandler(void)
  : T32N0жϴ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void T32N0_IRQHandler(void)               //0.1sһж
{
 if(T32Nx_GetFlagStatus(T32N0,T32Nx_IT_MAT0 )  != RESET){

	  T32Nx_ClearITPendingBit(T32N0,T32Nx_IT_MAT0);
	  UART_SendByte(UART1,speed_value);
	 
	}
}



/*********************************************************
: void UART0_IRQHandler(void)
  : UARTжϷ
ֵ: 
ֵ: 
ֵ:  
**********************************************************/
void UART1_IRQHandler(void)
{
	unsigned char data=0;
	if ((UART_GetITStatus(UART1,UART_IT_RB) != RESET) && (UART_GetFlagStatus(UART1, UART_FLAG_RB) != RESET)){
		UART_ClearITPendingBit(UART1, UART_FLAG_RB);
	
		data = UART_RecByte(UART1);
		if(data == 0xff)
		{
			if(uart_receive_data.header_counter<=1)
				uart_receive_data.header_counter++;
			else
			{
				uart_receive_data.header_counter = 0;   //ݴ󣬶
				uart_receive_data.data_counter = 0;
				return;
			}
			
		}
		else
		{
		
			if(uart_receive_data.header_counter==2)
			{
				if(uart_receive_data.data_counter<2)
					uart_receive_data.receive_data.data8[uart_receive_data.data_counter] = data;
				if(uart_receive_data.data_counter==2)
					uart_receive_data.data_motor_state = data;
				uart_receive_data.data_counter++;
				if(uart_receive_data.data_counter == 3)  //ȷ
				{
					OLED_ShowNum(60,2,uart_receive_data.receive_data.data16,4,16);
					if(uart_receive_data.data_motor_state == 0x11)
						OLED_ShowString(60,4,"STOP");
					else if(uart_receive_data.data_motor_state == 0x44)
						OLED_ShowString(60,4,"VPRO");
					else if(uart_receive_data.data_motor_state == 0x55)
						OLED_ShowString(60,4,"IPRO");
					else if(uart_receive_data.data_motor_state == 0x22)
						OLED_ShowString(60,4,"RUNZ");
					else if(uart_receive_data.data_motor_state == 0x33)
						OLED_ShowString(60,4,"RUNF");
				}
				else if(uart_receive_data.data_counter > 3) //ݴ
				{
					uart_receive_data.header_counter = 0;   //ݴ󣬶
					uart_receive_data.data_counter = 0;
					return;	
				}
			
			}
			else
			{
				uart_receive_data.header_counter = 0;   //ݴ󣬶
				uart_receive_data.data_counter = 0;
				return;
			}
		}
			
	}
}



void KINT_IRQHandler(void)
{
	if(KINT_GetITFlag(GPIO_Pin_A24) != RESET){     
		KINT_ClearITFlag(GPIO_Pin_A24);		// SW4
		UART_SendByte(UART1,UART_POSI_FLAG);
		if(posi_meg_flag== 1)
		{
			posi_meg_flag= 0;
		}
	}
	if(KINT_GetITFlag(GPIO_Pin_A27) != RESET){
		KINT_ClearITFlag(GPIO_Pin_A27);		// SW5
		UART_SendByte(UART1,UART_MEG_FLAG);
		if(posi_meg_flag== 0)
		{
			posi_meg_flag= 1;
		}

	}
	
	if(KINT_GetITFlag(GPIO_Pin_A25) != RESET){
		KINT_ClearITFlag(GPIO_Pin_A25);		// SW3
		UART_SendByte(UART1,UART_STOP_FLAG);
		
	}
	if(KINT_GetITFlag(GPIO_Pin_A26) != RESET){
		KINT_ClearITFlag(GPIO_Pin_A26);		// SW2
		UART_SendByte(UART1,UART_START_FLAG);

	}
	
}




