/**********************************************************************
*                                                                    *
*       (c) 2002 - 2014  Shanghai Haier IC Co., Ltd.          *
*                                                                    *
*       www.ichaier.com     Support: support@ichaier.com               *
*                                                                    *
**********************************************************************

----------------------------------------------------------------------
File   : DEFAULT.ld
Purpose: Link file for DEFAULT FLASH
-------- END-OF-HEADER -----------------------------------------------
*/

OUTPUT_FORMAT("elf32-littlearm","elf32-littlearm","elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(__vector)

/*********************************************************************
*
*       Define stack sites here
*/


MEMORY
{
  FLASH (rx)  : ORIGIN = 0x00000000, LENGTH = 0x00009000
  RAM   (wx)  : ORIGIN = 0x20000000, LENGTH = 0x00002000
}

SECTIONS
{
  .text :
  {
    KEEP( *(.vectors));
    *(.text*);
    . = ALIGN(4);
    KEEP(*(.init));
    KEEP(*(.fini));
    . = ALIGN(4);
    *(.text*);
    . = ALIGN(4);
    *(.rodata);
    . = ALIGN(4);
    *(.rodata*);
    . = ALIGN(4);
    *(.glue_7t);
    . = ALIGN(4);
    *(.glue_7);
    . = ALIGN(4);
    etext = .;
  } > FLASH

  . = ALIGN(4);
  _etext = . ;
  PROVIDE (etext = .);

  _sidata = .;

  .data : AT (_etext)
  {
    PROVIDE (__data_start__ = .);
    PROVIDE (_data = .) ;
    *(.data*)
    . = ALIGN(4);
    PROVIDE (__data_end__ = .);
  } > RAM

  _my_rom_end  = _etext + (__data_end__ - __data_start__);

  . = ALIGN(4);
  _edata = . ;
  PROVIDE (edata = .);

  .bss :
  {
    PROVIDE (__bss_start__ = .);
    *(.bss*)
    *(COMMON)
    . = ALIGN(4);
    PROVIDE (__bss_end__ = .);

    . = ALIGN(256);

  } > RAM

   .heap :
  {
    PROVIDE (__heap_start = .);
    *(.heap*)
    PROVIDE (__heap_end__ = .);
  } > RAM 

  .stack :
  {
    PROVIDE (__stack_start = .);
    *(.stack)
    PROVIDE (__stack_end__ = .);
  } > RAM 

  .ram_text : AT (_my_rom_end) 
  {
    . = ALIGN(4);
    _my_ram_end = .;
    _my_ram_end_d = .;
  } > RAM 
}
